#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi 

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

$lock_tables = "true";

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
#use acs;

&get_setup;
$q = CGI->new;

#acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") {&manual_backup1;} ## START BACKUP
if ($q->param('fct') eq "manual2") {&manual_backup2;} ## BACKUP PROCESS

###################################################################################


sub manual_backup1
{

print qq[
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/manual_back.cgi?fct=manual2">
</head>
<body>

<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="1%" valign="top"><img src="$web_url/templm.gif"></td>
    <td width="99%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Data
    Backup in Progress</strong></font><p><img src="$web_url/working.gif"></p>
    <p><strong><font face="Verdana" size="1">Please Wait...</font></strong><br>
    </td>
  </tr>
</table>

</body>
</html>
];




}



#################

sub manual_backup2
{

### GET TABLES

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

	$sql = "SHOW TABLES";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
	$icnt = 0;
	
while ( @row = $sth->fetchrow() )
		{
		$all_tables[$icnt] = $row[0];
		$icnt++;
		}


####### WRITE CONTENTS OF TABLE TO BACKUP FILE

if ((-e "$data_dir/dbbackup") < 1)
	{ 
	mkdir ("$data_dir/dbbackup", $default_permissions);
	chmod($default_permissions,"$data_dir/dbbackup","$data_dir/dbbackup");
	}
open (BACKUPF, "> $data_dir/dbbackup/backup.sql");

#######


foreach $table(@all_tables)
	{
	
	print BACKUPF "LOCK TABLES $table WRITE;\n";
	
	$sql = "DESCRIBE $table";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
	$icnt = 0;

	### GET COLUMNS
	$colums = "";
	$colums_counter = 0;
	while ( @row = $sth->fetchrow() )
			{
			$colums = $colums . "$row[0],";
			$colums_counter++;
			}
			$colums = substr($colums, 0, length($colums) - 1);


	$sql = "SELECT * FROM $table";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
	$rows = $sth->rows();
	
	
	while ( @row = $sth->fetchrow() )
			{
			$values = "";
			for ($ms = 0; $ms < $colums_counter; $ms++)
				{
				$row[$ms] =~ s/'/\\'/g; 
				
				$crit = chr(13);
				$row[$ms] =~ s/$crit//g;

				$crit = chr(10);
				$row[$ms] =~ s/$crit//g;
				
				$row[$ms] =~ s/\n//gi;
				$values = $values . "'$row[$ms]',"; 
				}
				$values = substr ($values, 0, length($values) - 1);
			
			print BACKUPF "INSERT INTO $table ($colums) VALUES ($values);\n";
			
			}
	
	
	print BACKUPF "UNLOCK TABLES;\n\n\n";
	
	}


$sth->finish;
$dbh->disconnect;

close (BACKUPF);


print qq[
<html>

<head>
<title>Data Backup</title>
</head>

<body>

<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="1%" valign="top"><img src="$web_url/templm.gif"></td>
    <td width="99%" valign="top"><strong><strong><font face="Arial" size="4" color="#000000">Backup
    Complete<br>
    </font></strong></strong><a href="$admin_url/admin43.cgi"><font face="Verdana" size="1"
    color="#000000">Click here to continue</font></a></td>
  </tr>
</table>
</body>
</html>
];


}


 



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

